import java.util.*;
import java.io.*;

public class histograma
{
    
    public static void main(String args[])
    {
	String verif;
	
	if( args.length<1||args.length>2 ){
	    System.out.println("ERROR");
	    System.out.println("USO:histograma <entrada> opcion<salida>");
	    return;
	}
	Hashtable words = new Hashtable();
	int c = ' ';
	
	
	//DECLARAR Y ABRIR UN FICHERO DE ENTRADA
	FileInputStream Ffichero;
	DataInputStream Dfichero;
	try{
	    Ffichero = new FileInputStream(args[0]);
	}catch( FileNotFoundException e ){
	    System.out.println("ERROR: no existe el archivo");
	    return;
	}
	Dfichero = new DataInputStream(Ffichero);
	
	while (c >= 0)
	    {
		try {
		    StringBuffer w = new StringBuffer();
		    do
			{
			    
			    c = Dfichero.read();
			    if (Character.isLowerCase((char)c))
				c = Character.toUpperCase((char)c);
			    if (Character.isUpperCase((char)c)){
				w.append((char)c);
				
			    }
			    else
				break;
			}
		    while (true);
		    
		    if (w.length() > 0)
			{
			    String s = w.toString();
			    if (words.containsKey(s))
				{
				    Integer cnt = (Integer)words.get(s);
				    words.put(s, new Integer(cnt.intValue()+1));
				}
			    else
				{
				    words.put(s, new Integer(1));
				}
			    
			}
		}
		catch (java.io.IOException e) {c = -1; System.out.println("FIN..."); }
	    }
	
	
	
	Vector concord = new Vector();
	for (Enumeration e = words.keys(); e.hasMoreElements();)
	    {
		String w = (String)e.nextElement();
		Integer cnt = (Integer)words.get(w);
		concord.add (new WordCounts(w, cnt.intValue()));
	    }
	
	for (int i = 1; i < concord.size(); ++i)
	    {
		WordCounts element = (WordCounts)concord.get(i);
		int j = i - 1;
		while ((j >= 0)
		       &&
		       (element.compareTo((WordCounts)concord.get(j)) < 0))
		    {
			concord.set(j+1, concord.get(j));
			j--;
		    }
		concord.set(j+1, element);
	    }
	//DECLARAR Y ABRIR UN FICHERO DE SALIDA	
	FileOutputStream salida;
	DataOutputStream datosalida;
	
	try{
	if(args.length==2)
	    salida = new FileOutputStream(args[1]);
	else
	    salida = new FileOutputStream("histograma.out");
	
	}catch( FileNotFoundException e ){
	    return;
	}

	datosalida = new DataOutputStream(salida);
	

	for (int j = 0; j < concord.size(); j++)
	    {
		WordCounts wc = (WordCounts)concord.get(j);
		
		try{
		    datosalida.writeBytes(wc.word + ' ' + wc.count + '\n');
		}catch(IOException e){
		}
	    }
	
	
    }
    

};
